package bvh.jmd;

import java.awt.geom.*;
import java.awt.geom.Ellipse2D;
import robocode.*;
/**
 * Slagveld - deze class bevat basis gegegevens m.b.t. het slagveld,
 * zoals bijv. de grootte:
 *
 * Verder bevat deze class methoden om de afstand tot wanden, hoeken
 * en dichts bijzijnde hoek te bepalen.
 */
class Slagveld implements Constanten {

// variabelen voor strijdperk:
   public  static RoundRectangle2D.Double   afmetingen;
   public  Ellipse2D.Double                 minimumCirkel, maximumCirkel;
   public  Point2D.Double                   middelpunt;
   private static double                    xMax, yMax, xM, yM;

   public Slagveld(AdvancedRobot bot) { // constructor
      this.xMax       = bot.getBattleFieldWidth();
      this.yMax       = bot.getBattleFieldHeight();
      this.xM         = xMax/2D;
      this.yM         = yMax/2D;
      this.middelpunt = new Point2D.Double(xM, yM);
      this.afmetingen = new RoundRectangle2D.Double( WANDAFSTAND
                                                   , WANDAFSTAND
                                                   , xMax - WANDAFSTAND * 2
                                                   , yMax - WANDAFSTAND * 2
                                                   , RONDING
                                                   , RONDING
                                                   );
      // initialiseer omhullenden die bepalend zijn voor inschatten positie van
      // doel op het slagveld:
      minimumCirkel = new Ellipse2D.Double( xMax/2D - DIAMETERBINNENCIRKEL/2D
                                          , yMax/2D + DIAMETERBINNENCIRKEL/2D
                                          , DIAMETERBINNENCIRKEL
                                          , DIAMETERBINNENCIRKEL);
      maximumCirkel = new Ellipse2D.Double( 0
                                          , 0
                                          , xMax
                                          , yMax);

   }

// Constructors
   public Slagveld(double xMax, double yMax)
   {
      this.xMax       = xMax;
      this.yMax       = yMax;
      this.xM         = xMax/2D;
      this.yM         = yMax/2D;
      this.middelpunt = new Point2D.Double(xM, yM);
      this.afmetingen = new RoundRectangle2D.Double( WANDAFSTAND
                                                   , WANDAFSTAND
                                                   , xMax - WANDAFSTAND * 2
                                                   , yMax - WANDAFSTAND * 2
                                                   , RONDING
                                                   , RONDING
                                                   );
      // initialiseer omhullenden die bepalend zijn voor inschatten positie van
      // doel op het slagveld:
      minimumCirkel = new Ellipse2D.Double( xMax/2D - DIAMETERBINNENCIRKEL/2D
                                          , yMax/2D + DIAMETERBINNENCIRKEL/2D
                                          , DIAMETERBINNENCIRKEL
                                          , DIAMETERBINNENCIRKEL);
      maximumCirkel = new Ellipse2D.Double( 0
                                          , 0
                                          , xMax
                                          , yMax);

   }

   public static double xBinnenSlagveld(double x) {
      if      (x < 18D      ) return (18D); // 18 is halve breedte van een robot
      else if (x > xMax-18D ) return (xMax-18D);
      else                    return (x);
   }

   public static double yBinnenSlagveld(double y) {
      if      (y < 18D      ) return (18D);
      else if (y > yMax-18D ) return (yMax-18D);
      else                    return (y);
   }

   public static Point2D.Double BinnenSlagveld(Point2D.Double p) {
      p.x = xBinnenSlagveld( p.x );
      p.y = yBinnenSlagveld( p.y );
      return (p);
   }
 }
/**********************************************************************
** EINDE CLASS SLAGVELD
**********************************************************************/
